const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const clauses = sequelize.define(
    'clauses',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

clause_code: {
        type: DataTypes.TEXT,
      
      

      },

title: {
        type: DataTypes.TEXT,
      
      

      },

text_excerpt: {
        type: DataTypes.TEXT,
      
      

      },

guidance_notes: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  clauses.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


































//end loop



    db.clauses.belongsTo(db.standards, {
      as: 'standard',
      foreignKey: {
        name: 'standardId',
      },
      constraints: false,
    });




    db.clauses.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.clauses.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return clauses;
};


